/*--------------------------------------------------------------------------
			I N T E R F A C E

 
       Just a few utility function for creating interfaces.
       
       Mark Koennecke, June 1997
 
       Copyright:

       Labor fuer Neutronenstreuung
       Paul Scherrer Institut
       CH-5423 Villigen-PSI


      The authors hereby grant permission to use, copy, modify, distribute,
      and license this software and its documentation for any purpose, provided
      that existing copyright notices are retained in all copies and that this
      notice is included verbatim in any distributions. No written agreement,
      license, or royalty fee is required for any of the authorized uses.
      Modifications to this software may be copyrighted by their authors
      and need not follow the licensing terms described here, provided that
      the new terms are clearly indicated on the first page of each file where
      they apply.

      IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
      FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
      ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
      DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
      POSSIBILITY OF SUCH DAMAGE.

      THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
      INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
      FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
      IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
      NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
      MODIFICATIONS.
----------------------------------------------------------------------------*/
#include <string.h>
#include <stdlib.h>
#include <assert.h>
#include "fortify.h"
#include "conman.h"
#include "obdes.h"
#include "interface.h"

/*-------------------------------------------------------------------------*/
  pIDrivable CreateDrivableInterface(void)
  {
    pIDrivable pRes = NULL;
    
    pRes = (pIDrivable)malloc(sizeof(IDrivable));
    if(!pRes)
    {
      return NULL;
    }
    memset(pRes,0,sizeof(IDrivable));
    pRes->ID = DRIVEID;
    return pRes;
  }
/*-------------------------------------------------------------------------*/
  pICountable CreateCountableInterface(void)
  {
    pICountable pRes = NULL;
    
    pRes = (pICountable)malloc(sizeof(ICountable));
    if(!pRes)
    {
      return NULL;
    }
    memset(pRes,0,sizeof(ICountable));
    pRes->ID = COUNTID;
    return pRes;
  }

/*---------------------------------------------------------------------------*/
  pEVInterface CreateEVInterface(void)
  {
    pEVInterface pRes = NULL;
    
    pRes = (pEVInterface)malloc(sizeof(EVInterface));
    if(!pRes)
    {
      return NULL;
    }
    memset(pRes,0,sizeof(EVInterface));
    pRes->iID = ENVIRINTERFACE;
    return pRes;
  }
/*--------------------------------------------------------------------------*/
  static void *FindInterface(void *pObject, int iID)
  {
     pDummy pDum = NULL;
     
     pDum = (pDummy)pObject;
     if(!pDum)
     {
       return NULL;
     }
     if(!pDum->pDescriptor)
     {
       return NULL;
     }
     
     return pDum->pDescriptor->GetInterface(pDum,iID);
  }
/*--------------------------------------------------------------------------*/
  pIDrivable GetDrivableInterface(void *pObject)
  {
      return (pIDrivable)FindInterface(pObject,DRIVEID);
  }  
/*--------------------------------------------------------------------------*/
  pICountable GetCountableInterface(void *pObject)
  {
      return (pICountable)FindInterface(pObject,COUNTID);
  } 
  
